<template>
	<mobile-frame>
		<view class="main">
			<view class="one">
				<scroll-view scroll-y="true" class="scroll-view">
					<view class="list-scroll-view">
						<view class="one_1">
							<swiper class="swiper" circular :indicator-dots="true" indicator-color="#ffffff" indicator-active-color="#FB1438" :autoplay="true" :interval="3000" :duration="1000">
								<swiper-item class="list" v-for="(item,index) in info.goods.file" :key="index">
									<image class="image" :src="item.url" mode="aspectFit">
									</image>
								</swiper-item>
							</swiper>
							<!-- 是否关注商品 -->
							<view class="goodsColect">
								<text @tap="toGoodscolect" :class="['iconfont',goodsColect?'icon-yduishoucangshixin-copy':'icon-yduishoucangkongxin']"></text>
							</view>
						</view>
						<view class="one_2">
							<text class="money"><text>¥</text>{{info.specs&&info.specs.length>0?info.specs[0].sell_money:0}}</text>
							<text class="money"><text>¥</text>{{info.specs&&info.specs.length>0?info.specs[0].flow_money:0}}</text>
						</view>
						<view class="one_3">
							<view class="name">
								{{info.goods.name}}
							</view>
							<view class="brief">
								{{info.goods.shot_brief||''}}
							</view>
							<view class="money">
								<text>运费{{info.specs&&info.specs.length>0?info.specs[0].freight:0}}元</text>
								<text>{{info.goods.send_time}}内发货</text>
							</view>
						</view>
						<view class="one_4" @tap="toSpec">
							<view class="l">
								选择规格
							</view>
							<view class="r">
								<text class="iconfont icon-jiantouyou"></text>
							</view>
						</view>
						<view class="one_5" @tap="toEvaluate">
							<view class="l">
								<text>{{evaluate_num>0?`商品评价(${evaluate_num})`:`暂无评价`}}</text>
							</view>
							<view class="r">
								<text class="iconfont icon-jiantouyou"></text>
							</view>
						</view>
						<view class="one_6">
							<view class="one_6_1">
								<view class="shop_1">
									<image class="image" :src="info.shop.logo&&info.shop.logo.length>0?info.shop.logo[0].url:''" mode="aspectFit"></image>
								</view>
								<view class="shop_2">
									<view class="name">{{info.shop.name}}</view>
									<view class="num"><text>宝贝数：</text>{{info.shop.goods_num||0}}</view>
								</view>
							</view>
							<view class="one_6_2">
								<view class="score_1">
									<text>商品：</text>
									<text>{{info.shop.goods_score||5}}</text>
									<text>|</text>
								</view>
								<view class="score_1">
									<text>发货：</text>
									<text>{{info.shop.send_score||5}}</text>
									<text>|</text>
								</view>
								<view class="score_1">
									<text>服务：</text>
									<text>{{info.shop.service_score||5}}</text>
								</view>
							</view>
							<view class="one_6_3">
								<button size="mini" @tap="toShop">进入店铺</button>
								<button size="mini" @tap="toShopcolect">{{shopColect==true?'已关注':'关注'}}</button>
							</view>
						</view>
						<view class="one_7">
							<rich-text :nodes="info.goods.brief"></rich-text>
						</view>
					</view>
				</scroll-view>
			</view>
			<view class="two">
				<uni-goods-nav :options="options" :button-group="buttonGroup" @click="toNavleft" @buttonClick="toNavright" />
			</view>
		</view>
		<!-- 跳转菜单 -->
		<view class="bar_1">
			<text @tap="toMenubar" class="iconfont icon-gengduo"></text>
		</view>
		<view class="bar_2" v-if="is_menu">
			<view class="list" v-for="(item,index) in barList" :key="index" v-if="item.is_use=='0'" @click="toPath(item)">
				<image class="image" :src="item.normal&&item.normal.length>0?item.normal[0].url:''"></image>
				<text class="name"> {{item.name}}</text>
			</view>
		</view>
		<!-- 规格 -->
		<uni-popup ref="specShow" background-color="#fff" type="bottom" :is-mask-click="false">
			<view class="popup">
				<view class="close">
					<text @click="toClose" class="iconfont icon-shanchu"></text>
				</view>
				<view class="info_1" v-if="popupShow=='1'">
					<view class="info_1">
						<scroll-view scroll-y="true" class="scroll-view">
							<view class="list-scroll-view">
								<view class="one">
									<view class="one_1">
										<view class="l">
											<image class="image" :src="specsInfo.file.length>0?specsInfo.file[0].url:info.goods.file[0].url" mode="aspectFill" @tap="imageView(specsInfo.file)"></image>
										</view>
										<view class="r">
											<view class="money">
												<text class="money_1"><text>¥</text>{{specsInfo.sell_money}}</text>
												<text class="money_1"><text>¥</text>{{specsInfo.flow_money}}</text>
											</view>
											<view class="other_1">
												<text>已选：</text>
												<text>{{specsInfo.name}}</text>
											</view>
										</view>
									</view>
									<view class="one_2">
										<view class="one_2_1">
											规格
										</view>
										<view class="one_2_2">
											<view :class="['list',`${item.num==0?'zero_list':''}`,`${is_specs==index?'one_list':''}`]" v-for="(item,index) in info.specs" :key="index" @tap="toSpecs(item)">
												<text>{{item.name}}</text>
											</view>
										</view>
									</view>
									<view class="one_3">
										<view class="one_3_1">
											<text>数量</text>
										</view>
										<view class="one_3_1">
											<uni-number-box v-model="buy_num" @change="toCount" :min="1" :max="specsInfo.num">
											</uni-number-box>
										</view>
										<view class="one_3_1">
											<text>库存{{specsInfo.num||0}}</text>
										</view>
									</view>
								</view>
							</view>
						</scroll-view>
					</view>
					<view class="info_2">
						<button size="mini" v-if="btn_type==''||btn_type=='0'" @tap="toMarket">加入购物车</button>
						<button size="mini" v-if="btn_type==''||btn_type=='1'" @tap="toBuy">立即购买</button>
						<button size="mini" v-if="specsInfo.can_group=='0'" @tap="toGroup">参团</button>
					</view>
				</view>
			</view>
		</uni-popup>
	</mobile-frame>
</template>

<script>
	export default {
		data() {
			return {
				// 商品id
				id: '',
				// 分享人id
				inviter: '',
				// 当前用户信息
				user: {},
				// 是否关注商品
				goodsColect: false,
				// 是否关注店铺
				shopColect: false,
				// 评价数
				evaluate_num: 2,
				// 商品详情
				info: {},
				// 底部菜单
				options: [ //
					{
						icon: 'shop',
						text: '店铺',
						type: 'shop',
						route: 'pagesHome/shop/index',
					},
					{
						icon: 'cart',
						text: '购物车',
						type: 'market',
						route: 'pages/market/index',
					},
				],
				buttonGroup: [ //
					{
						text: '加入购物车',
						backgroundColor: 'linear-gradient(90deg, #FFCD1E, #FF8A18)',
						color: '#fff',
						type: '0'
					},
					{
						text: '立即购买',
						backgroundColor: 'linear-gradient(90deg, #FE6035, #EF1224)',
						color: '#fff',
						type: '1'
					}
				],
				// 系统菜单
				barList: [],
				is_menu: false,
				// 规格
				popupShow: '1',
				// 规格信息
				is_specs: 0,
				btn_type: '',
				specsInfo: {},
				// 购买数量
				buy_num: 1,
			};
		},
		onLoad: async function(e) {
			const that = this;
			that.$set(that, `id`, e.id || '635e4b5b42e87c7a2880d0a8');
			that.$set(that, `inviter`, e.inviter || '');
			await that.searchConfig();
			await that.search();
		},
		onShow: async function() {
			const that = this;
			await that.watchLogin();
			that.configShare();
		},
		methods: {
			// 查询系统设置
			searchConfig() {
				const that = this;
				uni.getStorage({
					key: 'config',
					success: function(res) {
						let data = res.data;
						if (data.bottom_menu && data.bottom_menu.list.length > 0) {
							let list = data.bottom_menu.list.sort((a, b) => {
								return a.sort - b.sort
							});
							that.$set(that, `barList`, list)
						}

					}
				})
			},
			// 查询用户信息
			watchLogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: async function(res) {
						let user = that.$jwt(res.data);
						if (user) that.$set(that, `user`, user);
						await that.searchOther();
					},
					fail: function(err) {
						console.log('暂无用户信息');
					}
				})
			},
			// 查询其他信息
			async searchOther() {
				const that = this;
				let user = that.user;
				let res;
				// 是否关注商品
				res = await that.$api(`/storeGoods/check`, `GET`, {
					customer: user._id,
					goods: that.id
				});
				if (res.errcode == '0') that.$set(that, `goodsColect`, res.data);
				// 是否关注店铺
				res = await that.$api(`/storeShop/check`, `GET`, {
					customer: user._id,
					shop: that.info.shop._id
				});
				if (res.errcode == '0') that.$set(that, `shopColect`, res.data)

			},
			// 查询商品信息
			async search() {
				const that = this;
				let id = that.id;
				if (id) {
					let res;
					res = await that.$api(`/viewGoods/goodsDetail`, `POST`, {
						id: id
					});
					if (res.errcode == '0') {
						let data = res.data;
						if (data.goods.brief) data.goods.brief = data.goods.brief.replace(/\<img/gi, '<img class="rich-img"');
						let specs = data.specs.sort((a, b) => {
							return a.sell_money - b.sell_money
						})
						data.specs = specs;
						that.$set(that, `info`, data);
						// 查询规格
						that.searchSpecs(data.specs);
						// 查询评价数
						that.searchRate(data);
					}
				} else {
					uni.showToast({
						title: '暂无商品信息',
						icon: 'none'
					})
				}
			},
			// 查询规格
			searchSpecs(e) {
				const that = this;
				if (e.length > 0) {
					let data = e.find(i => i.num > 0);
					let dataIndex = e.findIndex(i => i.id == data.id);
					if (data) {
						that.$set(that, `specsInfo`, data);
						that.$set(that, `is_specs`, dataIndex);
					}
				}
			},
			// 选择规格
			toSpecs(e) {
				const that = this;
				let specs = that.info.specs;
				if (e.num > 0) {
					let dataIndex = specs.findIndex(i => i.id == e.id);
					that.$set(that, `is_specs`, dataIndex);
					that.$set(that, `specsInfo`, e)
					that.$set(that, `buy_num`, 1);
				} else {
					uni.showToast({
						title: '库存量不足',
						icon: 'none'
					})
				}

			},
			// 计数器
			toCount(e) {
				const that = this;
				that.$set(that, `buy_num`, e)
			},
			// 查询评价数
			async searchRate(e) {
				const that = this;
				let res = await that.$api(`/goodsRate`, `GET`, {
					goods: e.goods._id
				})
				if (res.errcode == '0') that.$set(that, `evaluate_num`, res.total);
			},
			// 关注商品
			async toGoodscolect() {
				const that = this;
				let user = that.user;
				if (user && user._id) {
					let res = await that.$api(`/storeGoods`, `POST`, {
						customer: user._id,
						goods: that.id
					});
					if (res.errcode == '0') {
						uni.showToast({
							title: res.data.msg,
							icon: 'none'
						})
						that.$set(that, `goodsColect`, res.data.result)
					}
				} else {
					uni.showToast({
						title: '暂无账号，无法收藏商品',
						icon: 'none'
					})
				}
			},
			// 选择规格
			toSpec() {
				const that = this;
				this.$set(that, `popupShow`, '1')
				that.$refs.specShow.open();
			},
			// 加入购物车
			async toMarket() {
				const that = this;
				let user = that.user;
				let info = that.info;
				let specsInfo = that.specsInfo;
				if (user && user._id) {
					let obj = {
						customer: user._id,
						shop: info.shop._id,
						goods: info.goods._id,
						goodsSpec: specsInfo._id,
						num: that.buy_num,
						inviter: that.inviter
					}
					let res = await that.$api(`/cart`, 'POST', obj)
					if (res.errcode == '0') {
						uni.showToast({
							title: `加入购物车成功`,
							icon: 'none'
						})
						that.toClose();
					} else {
						uni.showToast({
							title: res.errmsg,
							icon: 'none'
						})
					}
				} else {
					uni.navigateTo({
						url: `/pages/login/index`
					})
				}
			},
			// 立即购买
			async toBuy() {
				const that = this;
				let user = that.user;
				let info = that.info;
				let specsInfo = that.specsInfo;
				if (user && user._id) {
					let obj = {
						customer: user._id,
						shop: info.shop._id,
						goods: info.goods._id,
						goodsSpec: specsInfo._id,
						num: that.buy_num,
						inviter: that.inviter
					}
					let res = await that.$api(`/util/checkCanBuy`, 'POST', obj)
					if (res.errcode == '0') {
						if (res.data.result == true) {
							uni.navigateTo({
								url: `/pagesHome/order/order?key=${res.data.key}`
							})
						} else {
							uni.showToast({
								title: res.data.msg,
								icon: 'none'
							})
						}
					} else {
						uni.showToast({
							title: res.errmsg,
							icon: 'none'
						})
					}
				} else {
					uni.navigateTo({
						url: `/pages/login/index`
					})
				}
			},
			// 参团
			toGroup() {
				const that = this;
				let specs_id = that.specsInfo._id;
				let id = that.id;
				uni.navigateTo({
					url: `/pagesHome/group/index?specs_id=${specs_id}&goods_id=${id}`
				})
			},
			// 关闭弹框
			toClose() {
				const that = this;
				that.$set(that, `btn_type`, '');
				that.$refs.specShow.close();
			},
			// 评价
			toEvaluate() {
				const that = this;
				uni.navigateTo({
					url: `/pagesHome/order/appraise?id=${that.info.goods._id}`
				})
			},
			// 进入店铺
			toShop() {
				const that = this;
				let info = that.info;
				uni.navigateTo({
					url: `/pagesHome/shop/index?id=${info.shop._id}`
				})
			},
			// 关注店铺
			async toShopcolect() {
				const that = this;
				let user = that.user;
				if (user && user._id) {
					let res = await that.$api(`/storeShop`, `POST`, {
						customer: user._id,
						shop: that.info.shop._id
					});
					if (res.errcode == '0') {
						uni.showToast({
							title: res.data.msg,
							icon: 'none'
						})
						that.$set(that, `shopColect`, res.data.result)
					}
				} else {
					uni.showToast({
						title: '暂无账号，无法关注商铺',
						icon: 'none'
					})
				}
			},
			// 店铺,购物车
			toNavleft(e) {
				const that = this;
				if (e.content.type == 'shop') {
					that.toShop();
				} else if (e.content.type == 'market') {
					let obj = {
						route: e.content.route
					}
					that.toPath(obj)
				}
			},
			// 加入购物车,立即购买
			toNavright(e) {
				const that = this;
				this.$set(that, `popupShow`, '1');
				that.$set(that, `btn_type`, e.content.type);
				that.$refs.specShow.open();
			},
			// 右侧菜单
			toMenubar() {
				const that = this;
				that.$set(that, `is_menu`, that.is_menu ? false : true)
			},
			toPath(e) {
				let url = `/${e.route}`;
				uni.reLaunch({
					url
				})
			},
			// 配置分享内容
			configShare() {
				const that = this;
				let id = that.id;
				let inviter = that.user && that.user._id ? that.user._id : '';
				let title = that.info && that.info.goods ? that.info.goods.name : '';
				let imageUrl = that.info && that.info.goods ? that.info.goods.file[0].url : '';
				that.$config.share = {
					title: title,
					path: `/pagesHome/order/detail?id=${id}&inviter=${inviter}`,
					imageUrl: imageUrl
				}
			},
			// 图片预览
			imageView(e) {
				const that = this;
				let goods = that.info.goods;
				let file = [];
				if (e && e.length > 0) file = e;
				else file = goods.file;
				file = file.map(i => i.url);
				uni.previewImage({
					current: 0,
					urls: file,
				})
			}
		}
	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			position: relative;
			flex-grow: 1;

			.one_1 {

				border-bottom: 0.5vw solid var(--f9Color);

				swiper {
					height: 44vh !important;
				}

				.list {
					border-radius: 5px;

					.image {
						width: 100%;
						height: 100%;
						border-radius: 5px;
						background-color: #fff;
					}
				}

				.goodsColect {
					position: fixed;
					top: 2vw;
					right: 3vw;
					background-color: #858585;
					border-radius: 90px;

					text {
						font-size: 30px;
					}
				}
			}

			.one_2 {
				border-bottom: 0.5vw solid var(--f9Color);
				padding: 2vw;

				.money {
					font-size: 20px;
					padding: 0 1vw 0 0;
					color: #ff0000;
					font-weight: bold;

					text {
						font-size: 14px;
					}
				}

				.money:last-child {
					font-size: 16px;
					color: #858585;
					text-decoration: line-through;
				}
			}

			.one_3 {
				border-bottom: 0.5vw solid var(--f9Color);
				padding: 2vw;

				.name {
					font-size: 17px;
					font-weight: bold;
					margin: 0 0 2vw 0;
				}

				.brief {
					font-size: 14px;
					color: #858585;
					margin: 0 0 1vw 0;
				}

				.money {
					font-size: 13px;
					color: #858585;

					text {
						padding: 0 2vw 0 0;
					}
				}
			}

			.one_4 {
				display: flex;
				justify-content: space-between;
				padding: 2vw;
				border-bottom: 0.5vw solid var(--f9Color);
				font-size: 14px;
			}

			.one_5 {
				display: flex;
				justify-content: space-between;
				padding: 2vw;
				border-bottom: 0.5vw solid var(--f9Color);
				font-size: 14px;
			}

			.one_6 {
				padding: 2vw;
				border-bottom: 0.5vw solid var(--f9Color);

				.one_6_1 {
					margin: 0 0 1vw 0;
					display: flex;

					.shop_1 {
						width: 15vw;
						height: 15vw;
						border: 1px solid #f1f1f1;

						.image {
							width: 100%;
							height: 100%;
						}
					}

					.shop_2 {
						width: 78vw;
						padding: 0 0 0 2vw;

						.name {
							font-size: 14px;
							margin: 0 0 1vw 0;
						}

						.num {
							font-size: 12px;
							color: #858585;

							text:last-child {
								color: #000;
							}
						}
					}
				}

				.one_6_2 {
					margin: 0 0 1vw 0;
					display: flex;
					justify-content: space-between;
					padding: 2vw 0;

					.score_1 {
						width: 33vw;
						text-align: center;
						font-size: 14px;
						color: #858585;

						text:nth-child(2) {
							color: #ff0000;
						}

						text:nth-child(3) {
							float: right;
						}
					}
				}

				.one_6_3 {
					text-align: center;

					button {
						margin: 0 2vw;
					}
				}
			}

			.one_7 {
				padding: 2vw;

				.rich-img {
					width: 100% !important;
					display: block;
				}
			}

		}

		.two {
			width: 100vw;
			height: 8vh;
			overflow: hidden;
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.bar_1 {
		position: fixed;
		right: 2vw;
		bottom: 20vw;

		text {
			background-color: #858585;
			border-radius: 90px;
			font-size: 30px;
		}
	}

	.bar_2 {
		position: fixed;
		right: 2vw;
		bottom: 28vw;
		width: 27vw;
		background: #ffffff;
		padding: 0 2vw;
		box-shadow: 0 0 5px #858585;

		.list {
			display: flex;
			border-bottom: 1px solid #f1f1f1;
			padding: 1vw 0;


			.image {
				width: 8vw;
				height: 8vw;
			}

			.name {
				font-size: 14px;
				position: relative;
				top: 2vw;
				left: 2vw;
			}
		}

		.list:last-child {
			border-bottom: none;
		}
	}

	.uni-popup {
		z-index: 9999 !important;
	}

	.popup {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 60vh;

		.close {
			text-align: right;
			padding: 2vw;
		}

		.info_1 {
			position: relative;
			display: flex;
			flex-direction: column;
			height: 54vh;

			.info_1 {
				position: relative;
				flex-grow: 1;

				.one {
					padding: 2vw;

					.one_1 {
						display: flex;
						margin: 0 0 2vw 0;
						padding: 0 0 2vw 0;
						border-bottom: 0.5vw solid var(--f9Color);

						.l {
							width: 25vw;
							height: 25vw;

							.image {
								width: 100%;
								height: 100%;
								border-radius: 5px;
							}
						}

						.r {
							width: 70vw;
							padding: 0 0 0 2vw;

							.money {

								margin: 0 0 2vw 0;

								.money_1 {
									font-size: 20px;
									color: #ff0000;
									padding: 0 2vw 0 0;

									text {
										font-size: 14px;
									}
								}

								.money_1:last-child {
									font-size: 16px;
									color: #858585;
									text-decoration: line-through;

								}
							}

							.other_1 {
								font-size: 15px;
								color: #858585;

								text:last-child {
									color: #000000;
								}
							}
						}
					}

					.one_2 {
						margin: 0 0 2vw 0;
						border-bottom: 0.5vw solid var(--f9Color);

						.one_2_1 {
							font-size: 14px;
							margin: 0 0 2vw 0;
						}

						.one_2_2 {
							display: flex;
							flex-wrap: wrap;

							.list {
								background-color: #f9f9f9;
								margin: 0 2vw 2vw 0;
								padding: 0.5vw 1vw;
								border-radius: 5px;

								text {
									font-size: 14px;
									color: #000;
								}
							}

							.zero_list {
								background-color: #f5f5f5;

								text {
									color: #858585;
								}
							}

							.one_list {
								background-color: red;

								text {
									color: #fff;
								}
							}
						}
					}

					.one_3 {
						display: flex;

						.one_3_1 {
							margin: 0 2vw 0 0;

							text {
								font-size: 14px;
								color: #858585;
							}
						}
					}
				}
			}

			.info_2 {
				text-align: center;
				height: 7vh;
				padding: 2vw 0;
				border-top: 0.5vw solid var(--f9Color);

				button {
					line-height: 3;
					margin: 0 2vw;
					padding: 0.3vw 6vw;
					background-color: #ff0000;
					color: #fff;
					font-weight: bold;
				}
			}
		}
	}
</style>
